package com.fjhx.sale.mapper.sample;

import com.fjhx.account.entity.account.vo.AccountRunningWaterVo;
import com.fjhx.sale.entity.contract.vo.ContractProductVo;
import com.fjhx.sale.entity.sample.po.Sample;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.fjhx.sale.entity.sample.vo.SampleVo;
import com.ruoyi.common.utils.wrapper.IWrapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;


/**
 * <p>
 * 样品单表 Mapper 接口
 * </p>
 *
 * @author
 * @since 2023-05-05
 */
public interface SampleMapper extends BaseMapper<Sample> {

    /**
     * 样品单表分页
     */
    Page<SampleVo> getPage(@Param("page") Page<Object> page, @Param("ew") IWrapper<Sample> wrapper);

    /**
     * 查询样品交接单列表
     * @param page
     * @param wrapper
     * @return
     */
    Page<ContractProductVo> sampleHandoverList(@Param("page") Page<Object> page, @Param("ew") IWrapper<Sample> wrapper);

    void updateSample(Sample sample);

    /**
     * 根据合同id获取合同的资金流水信息
     */
    List<AccountRunningWaterVo> getAccountRunningWaterBySampleId(@Param("sampleId") Long sampleId);
}
